"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = cleanFilePathSnapshot;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var path = _interopRequireWildcard(require("path"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof3(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var dirname = path.resolve(__dirname, '../../../../../');

/**
 * remove the root file path from the snapshot
 * this way it can be compared on every machine and in CI
 * @param snapshot 
 * @returns cleaned snapshot
 */
function cleanFilePathSnapshot(snapshot) {
  if (typeof snapshot === 'string') {
    return snapshot.replaceAll(dirname, '~');
  } else if (Array.isArray(snapshot)) {
    return snapshot.map(cleanFilePathSnapshot);
  } else if ((0, _typeof2["default"])(snapshot) === 'object') {
    return Object.keys(snapshot).reduce(function (acc, key) {
      acc[key] = cleanFilePathSnapshot(snapshot[key]);
      return acc;
    }, {});
  } else {
    return snapshot;
  }
}