"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getComponentVueDoc;
var fs = _interopRequireWildcard(require("fs"));
var path = _interopRequireWildcard(require("path"));
var _parseVue = _interopRequireDefault(require("./parseVue"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var readSeparateScriptFile = function readSeparateScriptFile(fileName) {
  return fs.readFileSync(fileName, {
    encoding: 'utf-8'
  });
};
function getComponentVueDoc(source, file) {
  var _descriptor$customBlo;
  var descriptor = (0, _parseVue["default"])(source);
  var docBlocks = (_descriptor$customBlo = descriptor.customBlocks) === null || _descriptor$customBlo === void 0 ? void 0 : _descriptor$customBlo.filter(function (block) {
    return block.type === 'docs';
  })[0];
  if (docBlocks !== null && docBlocks !== void 0 && docBlocks.src) {
    var jsFilePath = path.join(path.dirname(file), docBlocks.src);
    return readSeparateScriptFile(jsFilePath);
  } else if (docBlocks !== null && docBlocks !== void 0 && docBlocks.content) {
    return docBlocks.content;
  }
  return false;
}