import React from 'react';
import PropTypes from 'prop-types';
export interface IsolateButtonProps {
    name: string;
    example?: number;
    isolated?: boolean;
}
declare const IsolateButton: {
    ({ name, example, isolated }: IsolateButtonProps): React.JSX.Element;
    propTypes: {
        name: PropTypes.Validator<string>;
        example: PropTypes.Requireable<number>;
        isolated: PropTypes.Requireable<boolean>;
    };
};
export default IsolateButton;
